package de.ivu.elect.business.system.control.status;

import java.util.Collections;
import java.util.List;

import javax.inject.Inject;

import de.ivu.elect.business.mandant.entity.Mandant;
import de.ivu.elect.business.system.control.SystemRequirements;
import de.ivu.elect.business.system.entity.SystemStatusOptionGroup;
import de.ivu.elect.jee.presentation.status.StatusEntry;
import de.ivu.elect.jee.presentation.status.StatusOptionType;

/**
 *  on 26.05.2017.
 */
public class JvmMemorySystemStatusOptionResolver extends AbstractSystemStatusOptionResolver {

  @Inject
  SystemRequirements systemRequirements;

  private static final StatusOptionType MEMORY = new StatusOptionType() {
  };


  @Override
  protected StatusEntry resolveSystemStatusOption(SystemStatusOption systemStatusOption) {
    long erwartet = systemRequirements.getSpeicherInBytes();
    long vorhanden = Runtime.getRuntime().maxMemory();

    if (vorhanden >= erwartet) {
      return ok("system.info.konfiguriert.memory.ok", vorhanden);
    }
    return warn("system.info.konfiguriert.memory.nok", vorhanden, erwartet);
  }

  @Override
  protected boolean isAccept(Mandant mandant) {
    return mandant.getArt().isSystemMandant();
  }

  @Override
  protected List<SystemStatusOption> getStatusOptionsInternal(Mandant mandant) {
    return Collections.singletonList(new SystemStatusOption(MEMORY,mandant));
  }

  @Override
  public SystemStatusOptionGroup getSystemStatusOptionGroup() {
    return SystemStatusOptionGroup.JVM_START_OPTIONEN;
  }

}
